﻿var ApiUrl = "https://api.iradius.es/api/v101"; 
var Loading = false;
function token() {
    return document.getElementById('intoken').value;
}

function ApiAjaxCall(method, type, data, CallbackFunction) {
    $.ajax({
        url: ApiUrl + '/' + method,
        type: type,
        dataType: "json",
        data: data,
        async: true,
        headers: { "token": token() },
        success: function (result) {
            CallbackFunction(result);
        },
        error: function (jqXHR, textStatus, errorThrown) {
            alert(textStatus);
        }
    });
}

function AlertResultJson(result) {
    alert(JSON.stringify(result));
}

function SetInputValue(controlname, value) {
    document.getElementById(controlname).value = value;
}

function SetSelectOptions(controlname, data, ValueProperty, DescriptionProperty) {
    var options = '';
    for (var i = 0; i < data.length; i++) {
        options += '<option value="' + data[i][ValueProperty] + '">' + data[i][DescriptionProperty] + '</option>';
    }
    document.getElementById(controlname).innerHTML = options;
}

//User
function GetCurrentUser() {
    ApiAjaxCall('User', 'GET', null, SetUserName);
}
function SetUserName(result) {
    document.getElementById('inUser').value = JSON.stringify(result);
}

//AvailableCustomers
function GetCustomers() {
    ApiAjaxCall("AvailableCustomers", "GET", null, SetCustomers);
}
function SetCustomers(result) {
    Loading = true;
    SetSelectOptions("lstCustomers", result, "Id", "Name");
    Loading = false;
}
function OnChangeLstCustomers() {
    if (Loading) return;
    GetAvailableHotspots();
    GetAvailableTypes();
}

//AvailableHotspots
function GetAvailableHotspots() {
    var lst = document.getElementById("lstCustomers");
    var CustomerId = lst.options[lst.selectedIndex].value;
    var data = { CustomerId: CustomerId };
    ApiAjaxCall('AvailableHotspots', 'GET', data, SetAvailableHotspots);
}
function SetAvailableHotspots(result) {
    SetSelectOptions("lstHotspots", result, "Id", "Description");
}

//AvailableTypes
function GetAvailableTypes() {
    var lst = document.getElementById("lstCustomers");
    var CustomerId = lst.options[lst.selectedIndex].value;
    var data = { CustomerId: CustomerId };
    ApiAjaxCall('AvailableTypes', 'GET', data, SetAvailableTypes);
}
function SetAvailableTypes(result) {
    SetSelectOptions("lstTypes", result, "TypeId", "Description");
}

//GenerateCredentials
function GenerateCredentials() {
    var lst = document.getElementById("lstCustomers");
    var CustomerId = lst.options[lst.selectedIndex].value;

    lst = document.getElementById("lstHotspots");
    var HotspotId = lst.options[lst.selectedIndex].value;
    lst = document.getElementById("lstTypes");

    var TypeId = lst.options[lst.selectedIndex].value;

    var Quantity = document.getElementById("inQuantity").value;

    var data = {
        "Quantity": Quantity,
        TypeId: TypeId,
        "CustomerId": CustomerId,
        "HotSpotId": HotspotId
    };

    var d2 = JSON.stringify(data);
    ApiAjaxCall('GenerateCredentials', 'POST', data, GetGenerateCredentialsResult);
}

//GetCredentials
function GetCredentials(FilterEmails) {
    var lst = document.getElementById("lstCustomers");
    var CustomerId = lst.options[lst.selectedIndex].value;
    lst = document.getElementById("lstHotspots");
    var HotspotId = lst.options[lst.selectedIndex].value;
    lst = document.getElementById("lstTypes");
    var dateini = document.getElementById("dateini").value;
    var dateend = document.getElementById("dateend").value;

    var data = {
        "CustomerId": CustomerId,
        "HotSpotId": HotspotId,
        "DateIni": dateini,
        "DateEnd": dateend,
        "FilterEmails": FilterEmails
   };

    var d2 = JSON.stringify(data);
    ApiAjaxCall('Credentials', 'GET', data, GetCredentialsResult);
}

function GetCredentialsResult(result) {
    var r = "<table class='table table-striped'><thead><tr><th>Usuario</th><th>Email</th><th>Nombre</th><th>Tipo</th><th>F.nac</th>";
    r +="<th>Cod. Pos</th><th>Field1</th><th>Field2</th><th>Filed3</th><th>Info</th><th>Es hombre?</th><th>id Tipo</th><th>F. Creación</th><th>Origen</th><th></th></tr></thead><tbody id='tbbody'>";
    for (var i = 0; i < result.length; i++) {
        r += '<tr><td>' + result[i].UserName + '</td>'
            + '<td>' + result[i].Email + '</td>'
            + '<td>' + result[i].NAME + '</td>'
            + '<td>' + result[i].TypeDescription + '</td>'
            + '<td>' + result[i].BIRTHDATE + '</td>'
            + '<td>' + result[i].CODPOS + '</td>'
            + '<td>' + result[i].FIELD1 + '</td>'
            + '<td>' + result[i].FIELD2 + '</td>'
            + '<td>' + result[i].FIELD3 + '</td>'
            + '<td>' + result[i].INFO + '</td>'
            + '<td>' + result[i].IsMale + '</td>'
            + '<td>' + result[i].TypeId + '</td>'
            + '<td>' + result[i].CREATION_DATE + '</td>'
            + '<td>' + result[i].SourceType + '</td>'
        + '</tr > ';
    }
    r += "</tbody ></table>";
    document.getElementById("tableresult").innerHTML = r;
}

function GetGenerateCredentialsResult(result) {
    var r = "<table class='table table-striped'><thead><tr><th>Usuario</th><th>Contraseña</th></tr></thead><tbody id='tbbody'>";
    for (var i = 0; i < result.CredentialsResults.length; i++) {
        r += '<tr><td>' + result.CredentialsResults[i].UserName + '</td><td>' + result.CredentialsResults[i].Password + '</td></tr>';
    }
    r +="</tbody ></table>";
    document.getElementById("tableresult").innerHTML = r;
}